%{
//#include<string.h>
#include <cstring>        
#include<string>
#include<stdio.h>
#include<iostream.h>
#include "iniyacc.h"
extern int errorline;  //la debera generar el bison en iniyacc.h, pero no lo est haciendo
char* getName(string);
%}

%option yylineno
%option noyywrap 

DIGIT       [0-9]
SYMBOL      [-_&]
LETTER      [A-Za-z]
ID          ({LETTER}|{DIGIT}|{SYMBOL})*
B           " "*
LINE        ([[:print:]]*)\n

%%

{B}"|--"{B}"template"{B}{ID}{B}"--|"{B}"\n"        {inilval.s = getName(yytext);
                                                    errorline = yylineno - 1;
                                                    return TOK_TEMPLATE;
                                                   }

{B}"|--"{B}"end"{B}"template"{B}"--|"{B}"\n"       {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_ENDTEMPLATE;
                                                   }

{B}"|--"{B}"top"{B}"components"{B}"--|"{B}"\n"     {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_TOP_COMPONENTS;
                                                   }

{B}"|--"{B}"top"{B}"ports"{B}"--|"{B}"\n"          {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_TOP_PORTS;
                                                   }

{B}"|--"{B}"top"{B}"links"{B}"--|"{B}"\n"          {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_TOP_LINKS;
                                                   }

{B}"|--"{B}"before"{B}"neighbors"{B}"--|"{B}"\n"   {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_BEFORE_NEIGHBORS;
                                                   }

{B}"|--"{B}"neighbors"{B}"--|"{B}"\n"              {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_NEIGHBORS;
                                                   }

{B}"|--"{B}"before"{B}"ports"{B}"--|"{B}"\n"       {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_BEFORE_PORTS;
                                                   }

{B}"|--"{B}"ports"{B}"--|"{B}"\n"                  {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_PORTS;
                                                   }

{B}"|--"{B}"before"{B}"links"{B}"--|"{B}"\n"       {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_BEFORE_LINKS;
                                                   }

{B}"|--"{B}"links"{B}"--|"{B}"\n"                  {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_LINKS;
                                                   }

{B}"|--"{B}"before"{B}"zones"{B}"--|"{B}"\n"       {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_BEFORE_ZONES;
                                                   }

{B}"|--"{B}"zones"{B}"--|"{B}"\n"                  {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_ZONES;
                                                   }

{B}"|--"{B}"before"{B}"rules"{B}"--|"{B}"\n"       {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_BEFORE_RULES;
                                                   }

{B}"|--"{B}"rules"{B}"--|"{B}"\n"                  {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_RULES;
                                                   }

{B}"|--"{B}"after"{B}"rules"{B}"--|"{B}"\n"        {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_AFTER_RULES;
                                                   }

{B}"["{B}{ID}{B}"]"{B}"\n"                         {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_BLOCK;
                                                   }

{B}"|--"{B}"macros"{B}"--|"{B}"\n"                 {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_MACROS;
                                                   }

{B}"|--"{B}"end"{B}"macros"{B}"--|"{B}"\n"         {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_END_MACROS;
                                                   }

{B}"#BeginMacro("{B}{ID}{B}")"{B}"\n"              {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_BEGIN_MACRO;
                                                   }

{B}"#EndMacro"{B}"\n"                              {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_END_MACRO;
                                                   }

{LINE}                                             {inilval.s = yytext;
                                                    errorline = yylineno - 1;
                                                    return TOK_LINE;
                                                   }

.                                                  {/* character not expected */
                                                    inilval.s = yytext; 
                                                    errorline = yylineno;
                                                    return  TOK_ERROR;
                                                   }

%%

char* getName(string text_cm){
int i;
text_cm.erase(text_cm.find("|--"),3);
text_cm.erase(text_cm.find("--|"),3);
text_cm.erase(text_cm.find("template"),8);
text_cm.erase(text_cm.find("\n"),1);
for (i = 0; i < text_cm.size(); i++)
   if (text_cm[i] == ' '){
      text_cm.erase(i,1);
      i--;
   }
return (char *) text_cm.c_str();
}

