#include "jobsite.h"

void Jobsite::setLane (int l)
{
  this->lane = l;
}

void Jobsite::setDistance (int d)
{
  this->distance = d;
}

void Jobsite::setQlane (int q)
{
  this->qlane = q;
}

void Jobsite::setDelay (int d)
{
  delay = d;
}

int Jobsite::getLane ()
{
  return this->lane;
}

int Jobsite::getDistance ()
{
  return this->distance;
}

int Jobsite::getQlane ()
{
  return this->qlane;
}

int Jobsite::getDelay ()
{
  return delay;
}

void Jobsite::setSegment (Segment * s)
{
  this->segment = s;
}

Segment * Jobsite::getSegment ()
{
  return this->segment;
}

void Jobsite::print ()
{
  cout << "Jobsite(" << this->lane << "," << this->distance << "," << this->qlane << ")";
}


string Jobsite::getCells ()
{

  int laneSeg = this->segment->getQlane ();
  char buff[5];
  string s;
  int i, j, k;

  if (this->lane == 1)
    for (i = 0; i < (this->qlane - 1) / 2; i++)
      for (j = this->qlane - 1 - i * 2; j > 0; j--)
	{
	  s += "(";
	  s += itoa (i, buff, 10);
	  s += ",";
	  s += itoa (this->distance - j - i, buff, 10);
	  s += ")";
	};

  k = -1;
  for (i = this->lane; i < this->lane + this->qlane; i++)
    {
      if (i <= this->lane + (this->qlane - 1) / 2)
	k++;
      else
	k--;
      for (j = this->distance - k; j <= this->distance + k; j++)
	{
	  s += "(";
	  s += itoa (i - 1, buff, 10);
	  s += ",";
	  s += itoa (j, buff, 10);
	  s += ")";
	};
    };

  if (this->lane + this->qlane - 1 == laneSeg)
    for (i = 0; i < (this->qlane - 1) / 2; i++)
      for (j = this->qlane - 1 - i * 2; j > 0; j--)
	{
	  s += "(";
	  s += itoa (laneSeg - i - 1, buff, 10);
	  s += ",";
	  s += itoa (this->distance - j - i, buff, 10);
	  s += ")";
	};

  return s;
}
