#ifndef __TEMPLATE_H
#define __TEMPLATE_H

#include <list.h>
#include <string>
#include "ruleblock.h"

//forward declarations
class RuleBlock;


class Template
{
public:
  void print ();                          //print all the info to the stdin  
  string getName ();
  void setName (string);
  bool getWasUsed ();
  void setWasUsed (bool);
  void addTopComponents (string c);
  void addTopPorts (string c);
  void addTopLinks (string c);
  void addBeforeNeighbors (string c);
  void addNeighbors (string c);
  void addBeforePorts (string c);
  void addPorts (string c);
  void addBeforeLinks (string c);
  void addLinks (string);
  void addBeforeZones (string);
  void addZones (string);
  void addBeforeRules (string);
  void addRules (RuleBlock *);
  void addAfterRules (string);
  list < string > *getTopComponents ();
  list < string > *getTopPorts ();
  list < string > *getTopLinks ();
  list < string > *getBeforeNeighbors ();
  list < string > *getNeighbors ();
  list < string > *getBeforePorts ();
  list < string > *getPorts ();
  list < string > *getBeforeLinks ();
  list < string > *getLinks ();
  list < string > *getBeforeZones ();
  list < string > *getZones ();
  list < string > *getBeforeRules ();
  list < RuleBlock > *getRules ();
  list < string > *getAfterRules ();

protected:
  string name;
  bool wasUsed;
  list < string > topComponents;
  list < string > topPorts;
  list < string > topLinks;
  list < string > beforeNeighbors;
  list < string > neighbors;
  list < string > beforePorts;
  list < string > ports;
  list < string > beforeLinks;
  list < string > links;
  list < string > beforeZones;
  list < string > zones;
  list < string > beforeRules;
  list < RuleBlock > rules;
  list < string > afterRules;
private:
};


#endif	/* __TEMPLATE_H */
