#include "templateName.h"

string TemplateName::getTNSegment (Segment * s)
{
  char buff[5];
  string name = "Segment-";
  name += itoa (s->getQlane (), buff, 10);
  name += "Lane";
  return name;
}

string TemplateName::getTNSegmentStart (Segment * s)
{
  char buff[5];
  string name = "Segment-";
  name += itoa (s->getQlane (), buff, 10);
  name += "Lane-";
  if (s->getStartCross () == NULL)
    name += "StartGenerator";
  else
    name += "StartCrossing";
  return name;
}

string TemplateName::getTNSegmentEnd (Segment * s)
{
  char buff[5];
  string name = "Segment-";
  name += itoa (s->getQlane (), buff, 10);
  name += "Lane-";
  if (s->getEndCross () == NULL)
    name += "EndConsumer";
  else
    name += "EndCrossing";
  return name;
}

string TemplateName::getTNSegmentTL (Segment * s)
{
  char buff[5];
  string name = "TrafficLightSegment-";
  name += itoa (s->getQlane (), buff, 10);
  name += "Lane";
  return name;
}

string TemplateName::getTNCrossing ()
{
  string name = "Crossing";
  return name;
}

string TemplateName::getTNCrossingTL ()
{
  string name = "TrafficLightCrossing";
  return name;
}

string TemplateName::getTNCrossingHole (Crossing * c)
{
  string name;
  if (c->getHole () == "withHole")
    name = "Crossing-with-Hole";
  else
    name = "Crossing-without-Hole";
  return name;
}

string TemplateName::getTNJobsite (Jobsite * j)
{
  string name = "JobsiteSegment";
  return name;
}

string TemplateName::getTNHole (Hole * h)
{
  char buff[5];
  string name = "HoleSegment-";
  name += itoa (h->getSegment ()->getQlane (), buff, 10);
  name += "Lane-";

  if (h->getDistance () == 0)
    {
      name += "Cell";
      name += itoa (h->getLane () - 1, buff, 10);
      name += "0";
    }
  else if (h->getDistance () == h->getSegment ()->getQcell () - 1)
    {
      name += "Cell";
      name += itoa (h->getLane () - 1, buff, 10);
      name += "n";
    }
  else
    {
      name += "Lane";
      name += itoa (h->getLane () - 1, buff, 10);
    }
  return name;
}

string TemplateName::getTNCtrElem (CtrElem * c)
{
  char buff[5];
  string name = "ControlSegment-";
  name += itoa (c->getSegment ()->getQlane (), buff, 10);
  name += "Lane-Cell";

  if (c->getDistance () == 0)
    name += "0";
  else if (c->getDistance () == c->getSegment ()->getQcell () - 1)
    name += "n";

  return name;
}

string TemplateName::getTNRail (Segment * s)
{
  char buff[5];
  string name = "TrainSegment-";
  name += itoa (s->getQlane (), buff, 10);
  name += "Lane";
  return name;
}

string TemplateName::getTNSincroRailnet ()
{
  string name = "SincroRailNet";
  return name;
}

string TemplateName::getTNTop ()
{
  string name = "Top";
  return name;
}
