#ifndef __CODEGEN_H
#define __CODEGEN_H

#include <fstream>
#include <list>
#include <map>
#include <string>
#include "traffic.h"
#include "segment.h"
#include "crossing.h"
#include "texception.h"
#include "codestruct.h"
#include "lineconvertor.h"
#include "template.h"
#include "ruleblock.h"
#include "macro.h"
#include "templatename.h"
#include "fileadmin.h"
#include "functionname.h"

//forward declarations
class Traffic;
class Segment;
class Crossing;
class TException;
class CodeStruct;
class LineConvertor;
class Template;
class RuleBlock;
class Macro;
class ModelName;
class FileAdmin;



extern CodeStruct codeStruct;
extern FileAdmin fileAdmin;
extern Traffic traffic;

class CodeGen {
public:
    void      generate();              // generate the code for the simulator

protected:
private:
    void      generateSegment(Segment*);  
    void      generateLineSegmentCall(Segment*,std::string);  
    void      generateRuleSegmentCall(Segment*,std::string);  
    void      generateLineSegment(Segment*,std::list<std::string>*,std::string);  
    void      generateLineHole(Hole*,std::list<std::string>*,std::string);  
    void      generateLineJobsite(Jobsite*,std::list<std::string>*,std::string);  
    void      generateLineCtrElem(CtrElem*,std::list<std::string>*,std::string);  
    void      generateLineRail(Segment*,Railnet*,std::list<std::string>*,std::string);  
    void      generateCrossing(Crossing*);  
    void      generateLineCrossingCall(Crossing*,std::string);  
    void      generateRuleCrossingCall(Crossing*,std::string);  
    void      generateLineCrossing(Crossing*,std::list<std::string>*,std::string);
    void      generateRailnet(Railnet*);  
    void      generateLineRailnet(Railnet*,std::list<std::string>*,std::string);
//*********    void      generateLine(std::list<std::string>*,std::string);  
    std::list<std::string>* (Template::*call)();
    void      clearDepWasUsed();
};

#endif /* __CODEGEN_H */
