#include <iostream>
#include "lineconvertor.h"
#include <stdio.h>

std::string LineConvertor::convertSegment(std::string line, Segment *s){
char buff[5];

// Replace of simple variables
line = convertLine(line,"%IDENTIF%",s->getIdent());
//line = convertLine(line,"%WIDTH%",itoa(s->getQcell(),buff,10));
sprintf(buff,"%d",s->getQcell());
line = convertLine(line,"%WIDTH%",buff);
//line = convertLine(line,"%HEIGHT%",itoa(s->getQlane(),buff,10));
sprintf(buff,"%d",s->getQlane());
line = convertLine(line,"%HEIGHT%",buff);
//line = convertLine(line,"%SPEED%",itoa(s->getSpeed(),buff,10));
sprintf(buff,"%d",s->getSpeed());
line = convertLine(line,"%SPEED%",buff);
line = convertLine(line,"%FIRST_LANE%","0");
//line = convertLine(line,"%LAST_LANE%",itoa(s->getQlane()-1,buff,10));
sprintf(buff,"%d",s->getQlane()-1);
line = convertLine(line,"%LAST_LANE%",buff);
line = convertLine(line,"%FIRST_CELL%","0");
//line = convertLine(line,"%LAST_CELL%",itoa(s->getQcell()-1,buff,10));
sprintf(buff,"%d",s->getQcell()-1);
line = convertLine(line,"%LAST_CELL%",buff);
//line = convertLine(line,"%DELAY%",itoa(s->getDelay(),buff,10));
sprintf(buff,"%d",s->getDelay());
line = convertLine(line,"%DELAY%",buff);

// Replace of multiple variables
line = convertForLine(line,"%LANE%",s->getQlane());
line = convertForLine(line,"%CELL%",s->getQcell());

if (getVariable(line)!=""){
    TemplateName* tn;
    std::string m = "Error in model ";
    m += (tn->getTNSegment(s));
    m += " for segment ";
    m += s->getIdent();
    m += " - Variable: " + getVariable(line) + " unknown";
    throw TException("convertSegment",m);
}

return line;
}


std::string LineConvertor::convertJobsite(std::string line, Jobsite *j){
char buff[5];
line = convertLine(line,"%JOBSITE_CELLS%",j->getCells());
//line = convertLine(line,"%DELAY%",itoa(j->getDelay(),buff,10));
sprintf(buff,"%d",j->getDelay());
line = convertLine(line,"%DELAY%",buff);
return line;
}

std::string LineConvertor::convertHole(std::string line, Hole *h){
char buff[5];
//line = convertLine(line,"%HOLE_CELL%",itoa(h->getDistance(),buff,10));
sprintf(buff,"%d",h->getDistance());
line = convertLine(line,"%HOLE_CELL%",buff);
//line = convertLine(line,"%HOLE_LANE%",itoa(h->getLane()-1,buff,10));
sprintf(buff,"%d",h->getLane()-1);
line = convertLine(line,"%HOLE_LANE%",buff);
//line = convertLine(line,"%DELAY%",itoa(h->getDelay(),buff,10));
sprintf(buff,"%d",h->getDelay());
line = convertLine(line,"%DELAY%",buff);
return line;
}

std::string LineConvertor::convertCtrElem(std::string line, CtrElem *c){
char buff[5];
//line = convertLine(line,"%CONTROL_CELL%",itoa(c->getDistance(),buff,10));
sprintf(buff,"%d",c->getDistance());
line = convertLine(line,"%DELAY%",buff);
return line;
}


std::string LineConvertor::convertRail(std::string line, Segment*s,Railnet*r){
char buff[5];
//line = convertLine(line,"%BEFORE_TRAIN_CELL%",itoa(r->findDistance(s->getIdent()), buff ,10));
sprintf(buff,"%d",r->findDistance(s->getIdent()));
line = convertLine(line,"%BEFORE_TRAIN_CELL%",buff);
//line = convertLine(line,"%AFTER_TRAIN_CELL%",itoa(r->findDistance(s->getIdent())+1, buff ,10));
sprintf(buff,"%d",r->findDistance(s->getIdent())+1);
line = convertLine(line,"%AFTER_TRAIN_CELL%",buff);
//line = convertLine(line,"%RAIL_ORDER%",itoa(r->findRailOrder(s->getIdent())-1, buff ,10));
sprintf(buff,"%d",r->findRailOrder(s->getIdent())-1);
line = convertLine(line,"%RAIL_ORDER%",buff);
line = convertLine(line,"%RAIL_IDENTIF%",r->getIdent());
//line = convertLine(line,"%DELAY%",itoa(r->getDelay(),buff,10));
sprintf(buff,"%d",r->getDelay());
line = convertLine(line,"%DELAY%",buff);


return line;
}


std::string LineConvertor::convertRailnet(std::string line, Railnet*r){
std::string  repLine, backupLine;
char buff[5];

// Replace of simple variables
line = convertLine(line,"%IDENTIF%",r->getIdent());
//line = convertLine(line,"%(SEGMENTS)%",itoa(r->getQsegs(),buff,10));
sprintf(buff,"%d",r->getQsegs());
line = convertLine(line,"%(SEGMENTS)%",buff);

// Replace of multiple variables
line = convertForLine(line,"%#SEGMENTS%",r->getQsegs());

if (line.find("%SEGMENTS%") != std::string::npos){
    repLine="";
    std::list< std::pair<Segment*, int> >* lRail = r->getLRail();
    std::list< std::pair<Segment*, int> >::iterator iter;

    backupLine=line; line="";
    for(iter = lRail->begin();iter != lRail->end();iter++){
         repLine = backupLine;
         repLine = convertLine(repLine,"%SEGMENTS%",(*iter).first->getIdent());
         line += repLine;
    }
}

if (getVariable(line)!=""){
    TemplateName* tn;
    std::string m = "Error in model ";
    m += (tn->getTNSincroRailnet());
    m += " for railnet ";
    m += r->getIdent();
    m += " - Variable: " + getVariable(line) + " unknown";
    throw TException("convertRailnet",m);
}
return line;
}

std::string LineConvertor::convertCrossing(std::string line, Crossing *c){
char buff[5];
// Replace of simple variables

line = convertLine(line,"%IDENTIF%",c->getIdent());
//line = convertLine(line,"%WIDTH%",itoa(c->getQcell(),buff,10));
sprintf(buff,"%d",c->getQcell());
line = convertLine(line,"%WIDTH%",buff);
//line = convertLine(line,"%SPEED%",itoa(c->getSpeed(),buff,10));
sprintf(buff,"%d",c->getSpeed());
line = convertLine(line,"%SPEED%",buff);
//line = convertLine(line,"%LAST_CELL%",itoa(c->getQcell()-1,buff,10));
sprintf(buff,"%d",c->getQcell()-1);
line = convertLine(line,"%LAST_CELL%",buff);
//line = convertLine(line,"%(IN)%",itoa(c->getQcellIn(),buff,10));
sprintf(buff,"%d",c->getQcellIn());
line = convertLine(line,"%(IN)%",buff);
//line = convertLine(line,"%(OUT)%",itoa(c->getQcellOut(),buff,10));
sprintf(buff,"%d",c->getQcellOut());
line = convertLine(line,"%(OUT)%",buff);
//line = convertLine(line,"%(IN_SEGMENTS)%",itoa(c->getQSegIn(),buff,10));
sprintf(buff,"%d",c->getQSegIn());
line = convertLine(line,"%(IN_SEGMENTS)%",buff);
//line = convertLine(line,"%(OUT_SEGMENTS)%",itoa(c->getQSegOut(),buff,10));
sprintf(buff,"%d",c->getQSegOut());
line = convertLine(line,"%(OUT_SEGMENTS)%",buff);
//line = convertLine(line,"%DELAY%",itoa(c->getDelay(),buff,10));
sprintf(buff,"%d",c->getDelay());
line = convertLine(line,"%DELAY%",buff);
//line = convertLine(line,"%POUT%",itoa(c->getPout(),buff,10));
sprintf(buff,"%d",c->getPout());
line = convertLine(line,"%POUT%",buff);


// Replace of multiple variables
std::string  repLine,backupLine;
int    i, sumSegLanes, qlane;
std::list<Segment*>* lSeg = c->getLSeg();
std::list<Segment*>::iterator   iter;

if (line.find("%IN%") != std::string::npos){
    sumSegLanes = 0;
    backupLine=line; line="";        
    for(iter = lSeg->begin();iter != lSeg->end();iter++){
       qlane=(*iter)->getQlane();
       if (c->isInSeg(*iter)){
          for (i=sumSegLanes;i<sumSegLanes+qlane;i++){
             repLine = backupLine;
             //repLine = convertLine(repLine,"%IN%",itoa(i,buff,10));
	     sprintf(buff,"%d",i);
	     repLine = convertLine(repLine,"%IN%",buff);	
             //repLine = convertLine(repLine,"%IN_SEGMENT%",(*iter)->getIdent());
	     sprintf(buff,"%d",(*iter)->getIdent());
	     repLine = convertLine(repLine,"%IN_SEGMENT%",(*iter)->getIdent());
             //repLine = convertLine(repLine,"%SEG_LANE_IN%",itoa(c->getSegmentLane(i),buff,10));
	     sprintf(buff,"%d",c->getSegmentLane(i));
             repLine = convertLine(repLine,"%SEG_LANE_IN%",buff);
             //repLine = convertLine(repLine,"%SEG_CELL_IN%",itoa((*iter)->getQcell()-1,buff,10));
	     sprintf(buff,"%d",(*iter)->getQcell()-1);		
	     repLine = convertLine(repLine,"%SEG_CELL_IN%",buff);
             line+=repLine;
          }
       }
       sumSegLanes+=qlane;
    }
}

if (line.find("%#IN%") != std::string::npos){
    sumSegLanes = 0;
    backupLine=line; line="";        
    for(iter = lSeg->begin();iter != lSeg->end();iter++){
       qlane=(*iter)->getQlane();
       if (c->isInSeg(*iter)){
          for (i=sumSegLanes;i<sumSegLanes+qlane;i++){
             repLine = backupLine;
             //repLine = convertLine(repLine,"%#IN%",itoa(i,buff,10));
	     sprintf(buff,"%d",i);
	     repLine = convertLine(repLine,"%#IN%",buff);
             repLine = convertLine(repLine,"%IN_SEGMENT%",(*iter)->getIdent());
             //repLine = convertLine(repLine,"%SEG_LANE_IN%",itoa(c->getSegmentLane(i),buff,10));
	     sprintf(buff,"%d",c->getSegmentLane(i));
   	     repLine = convertLine(repLine,"%SEG_LANE_IN%",buff);
             //repLine = convertLine(repLine,"%SEG_CELL_IN%",itoa((*iter)->getQcell()-1,buff,10));
	     sprintf(buff,"%d",(*iter)->getQcell()-1);
	     repLine = convertLine(repLine,"%SEG_CELL_IN%",buff);
             line+=repLine;
          }
          sumSegLanes+=qlane;
       }
    }
}

if (line.find("%#IN_SEGMENTS%") != std::string::npos){
    i = 0;
    backupLine=line; line="";        
    for(iter = lSeg->begin();iter != lSeg->end();iter++){
       if (c->isInSeg(*iter)){
          repLine = backupLine;
          //repLine = convertLine(repLine,"%#IN_SEGMENTS%",itoa(i,buff,10));
	  sprintf(buff,"%d",i);
	  repLine = convertLine(repLine,"%#IN_SEGMENTS%",buff);
          repLine = convertLine(repLine,"%IN_SEGMENT%",(*iter)->getIdent());
          //repLine = convertLine(repLine,"%SEG_LANE_IN%",itoa(c->getSegmentLane(i),buff,10));
	  sprintf(buff,"%d",c->getSegmentLane(i));
          repLine = convertLine(repLine,"%SEG_LANE_IN%",buff);
          //repLine = convertLine(repLine,"%SEG_CELL_IN%",itoa((*iter)->getQcell()-1,buff,10));
	  sprintf(buff,"%d",(*iter)->getQcell()-1);
	  repLine = convertLine(repLine,"%SEG_CELL_IN%",buff);
          line+=repLine;
          i+=1;
       }
    }
}

if (line.find("%IN_SEGMENTS%") != std::string::npos){
    sumSegLanes = 0;
    backupLine=line; line="";        
    for(iter = lSeg->begin();iter != lSeg->end();iter++){
       qlane=(*iter)->getQlane();
       if (c->isInSeg(*iter)){
          for (i=sumSegLanes;i<sumSegLanes+qlane;i++){
             repLine = backupLine;
             repLine = convertLine(repLine,"%IN_SEGMENTS%",(*iter)->getIdent());
             //repLine = convertLine(repLine,"%SEG_LANE_IN%",itoa(c->getSegmentLane(i),buff,10));
	     sprintf(buff,"%d",c->getSegmentLane(i));
	     repLine = convertLine(repLine,"%SEG_LANE_IN%",buff);
             //repLine = convertLine(repLine,"%SEG_CELL_IN%",itoa((*iter)->getQcell()-1,buff,10));
	     sprintf(buff,"%d",(*iter)->getQcell()-1);
	     repLine = convertLine(repLine,"%SEG_CELL_IN%",buff);
             line+=repLine;
          }
       }
       sumSegLanes+=qlane;
    }
}

if (line.find("%OUT%")!= std::string::npos){
    sumSegLanes = 0;
    backupLine=line; line="";        
    for(iter = lSeg->begin();iter != lSeg->end();iter++){
       qlane=(*iter)->getQlane();
       if (c->isOutSeg(*iter)){
          for (i=sumSegLanes;i<sumSegLanes+qlane;i++){
             repLine = backupLine;
             //repLine = convertLine(repLine,"%OUT%",itoa(i,buff,10));
	     sprintf(buff,"%d",i);
	     repLine = convertLine(repLine,"%OUT%",buff);
             repLine = convertLine(repLine,"%OUT_SEGMENT%",(*iter)->getIdent());
             //repLine = convertLine(repLine,"%SEG_LANE_OUT%",itoa(c->getSegmentLane(i),buff,10));
	     sprintf(buff,"%d",c->getSegmentLane(i));
	     repLine = convertLine(repLine,"%SEG_LANE_OUT%",buff);
             repLine = convertLine(repLine,"%SEG_CELL_OUT%","0");
             line+=repLine;
          }
       }
       sumSegLanes+=qlane;
    }
}

if (line.find("%#OUT%")!= std::string::npos){
    sumSegLanes = 0;
    backupLine=line; line="";        
    for(iter = lSeg->begin();iter != lSeg->end();iter++){
       qlane=(*iter)->getQlane();
       if (c->isOutSeg(*iter)){
          for (i=sumSegLanes;i<sumSegLanes+qlane;i++){
             repLine = backupLine;
             //repLine = convertLine(repLine,"%#OUT%",itoa(i,buff,10));
	     sprintf(buff,"%d",i);
	     repLine = convertLine(repLine,"%#OUT%",buff);
             repLine = convertLine(repLine,"%OUT_SEGMENT%",(*iter)->getIdent());
             //repLine = convertLine(repLine,"%SEG_LANE_OUT%",itoa(c->getSegmentLane(i),buff,10));
	     sprintf(buff,"%d",c->getSegmentLane(i));
	     repLine = convertLine(repLine,"%SEG_LANE_OUT%",buff);
             repLine = convertLine(repLine,"%SEG_CELL_OUT%","0");
             line+=repLine;
          }
          sumSegLanes+=qlane;
       }
    }
}

if (line.find("%#OUT_SEGMENTS%")!= std::string::npos){
    i = 0;
    backupLine=line; line="";        
    for(iter = lSeg->begin();iter != lSeg->end();iter++){
       qlane=(*iter)->getQlane();
       if (c->isOutSeg(*iter)){
          repLine = backupLine;
          //repLine = convertLine(repLine,"%#OUT_SEGMENTS%",itoa(i,buff,10));
	  sprintf(buff,"%d",i);
          repLine = convertLine(repLine,"%#OUT_SEGMENTS%",buff);
          repLine = convertLine(repLine,"%OUT_SEGMENT%",(*iter)->getIdent());
          //repLine = convertLine(repLine,"%SEG_LANE_OUT%",itoa(c->getSegmentLane(i),buff,10));
	  sprintf(buff,"%d",c->getSegmentLane(i));
	  repLine = convertLine(repLine,"%SEG_LANE_OUT%",buff);
          repLine = convertLine(repLine,"%SEG_CELL_OUT%","0");
          line+=repLine;
          i +=1;
       }
    }
}

if (line.find("%OUT_SEGMENTS%") != std::string::npos){
    sumSegLanes = 0;
    backupLine=line; line="";        
    for(iter = lSeg->begin();iter != lSeg->end();iter++){
       if (c->isOutSeg(*iter)){
          for (i=sumSegLanes;i<sumSegLanes+qlane;i++){
             repLine = backupLine;
             repLine = convertLine(repLine,"%OUT_SEGMENTS%",(*iter)->getIdent());
             //repLine = convertLine(repLine,"%SEG_LANE_OUT%",itoa(c->getSegmentLane(i),buff,10));
	     sprintf(buff,"%d",c->getSegmentLane(i));
	     repLine = convertLine(repLine,"%SEG_LANE_OUT%",buff);
             repLine = convertLine(repLine,"%SEG_CELL_OUT%","0");
             //repLine = convertLine(repLine,"%SEG_CELL_OUT%",itoa((*iter)->getQcell()-1,buff,10));
             sprintf(buff,"%d",(*iter)->getQcell()-1);
	     repLine = convertLine(repLine,"%SEG_CELL_OUT%",buff);
             line+=repLine;
          }
       }
       sumSegLanes+=qlane;
    }
}

if (line.find("%CELL%") != std::string::npos){
    sumSegLanes = 0;
    backupLine=line; line="";        
    for(iter = lSeg->begin();iter != lSeg->end();iter++){
       qlane=(*iter)->getQlane();
       for (i=sumSegLanes;i<sumSegLanes+qlane;i++){
          repLine = backupLine;
          //repLine = convertLine(repLine,"%CELL%",itoa(i,buff,10));
	  sprintf(buff,"%d",i);
	  repLine = convertLine(repLine,"%CELL%",buff);
          //repLine = convertLine(repLine,"%SEG_LANE%",itoa(c->getSegmentLane(i),buff,10));
	  sprintf(buff,"%d",c->getSegmentLane(i));
	  repLine = convertLine(repLine,"%SEG_LANE%",buff);
          if (c->isInSeg(*iter)){
             //repLine = convertLine(repLine,"%SEG_CELL%",itoa((*iter)->getQcell()-1,buff,10));
	     sprintf(buff,"%d",(*iter)->getQcell()-1);
	     repLine = convertLine(repLine,"%SEG_CELL%",buff);
	  }
          else
             repLine = convertLine(repLine,"%SEG_CELL%","0");
          line+=repLine;
       }
       sumSegLanes+=qlane;
    }
}

if (getVariable(line)!=""){
    TemplateName* tn;
    std::string m = "Error in model ";
    m += (tn->getTNCrossing());
    m += " for crossing ";
    m += c->getIdent();
    m += " - Variable: " + getVariable(line) + " unknown";
    throw TException("convertCrossing",m);
}

return line;
}


std::string LineConvertor::getVariable(std::string l){
std::string laux;
int    iaux;

laux = l;
iaux = laux.find("%");
if (iaux != std::string::npos){
   laux.erase(0, iaux+1);
   laux.erase(laux.find("%"), laux.size() - laux.find("%"));
   return("%"+laux+"%");
}
return("");
}


std::string LineConvertor::convertLine(std::string line, std::string transtring, std::string repstring){
int ubic = line.find(transtring);
while (ubic != std::string::npos){
      line.replace(ubic, transtring.size(), repstring);
      ubic = line.find(transtring);
}
return line;
}


std::string LineConvertor::convertForLine(std::string line, std::string transtring, int limit){
int i;
std::string repLine ="";
char buff[5];
if (line.find(transtring) != std::string::npos)
    for (i=0; i<limit; i++){
       repLine += line;
       //repLine = convertLine(repLine,transtring,itoa(i,buff,10));
       sprintf(buff,"%d",i);
       repLine = convertLine(repLine,transtring,buff);
    }
else repLine = line;
return repLine;

}
