#include <iostream.h>
#include "traffic.h"

Segment* Traffic::findSeg(std::string s){
bool ubic = false;
std::list<Segment*>::iterator  iterS;

iterS = this->lSeg.begin();
while ( iterS != this->lSeg.end() && !ubic )
   if ((*iterS)->getIdent()==s) ubic = true;
   else iterS++;

if(ubic == true) return *iterS;
else return NULL; 
};

void Traffic::addRailnet(Railnet *r){ this->lRailnet.push_back(r);};

void Traffic::addSeg(Segment *s){
std::list<Segment*>::iterator  iterS;
iterS = this->lSeg.begin();
if ( s->getFirstPoint() == s->getSecondPoint() ){
    std::string m = "Start point is equal than end point for segment ";
    m += s->getIdent();
    throw TException("addSeg",m);
    }    

s->calcIncls();
bool ubic = false;
while ( iterS != this->lSeg.end() && !ubic ){
   if ( (*iterS)->getMinorIncl() == s->getMinorIncl() &&
        ((*iterS)->getMinorPoint() == s->getMinorPoint() || (*iterS)->getMajorPoint() == s->getMajorPoint()))
       {
         std::string m = "Segments ";
         m += (*iterS)->getIdent();
         m += " and ";
         m += s->getIdent();
         m += " overlapped";
         throw TException("addSeg",m);
        }    
   if ( (*iterS)->getMinorIncl() > s->getMinorIncl() || 
        ((*iterS)->getMinorIncl() == s->getMinorIncl()&& (*iterS)->getMinorPoint() > s->getMinorPoint()))
       ubic = true;
   else 
       iterS++;
}
this->lSeg.insert(iterS, s);
}

void Traffic::addCross(Crossing *c) {
if (this->mCross.find(c->getPoint()) != this->mCross.end() )  {
   std::string m = "Crossings ";
   m += (this->mCross.find(c->getPoint()))->second->getIdent();
   m += " and ";
   m += c->getIdent();
   m += " defined in the same point";
   throw TException("addCross",m);
   }    

this->mCross.insert(std::map<Point,Crossing*>::value_type(c->getPoint(),c));
}


std::list<Segment*>* Traffic::getLSeg()         {return &(this->lSeg);}
std::list<Railnet*>* Traffic::getLRailnet()     {return &(this->lRailnet);}
std::map<Point, Crossing*>* Traffic::getMCross(){return &(this->mCross);}


void Traffic::print(){
   cout << "\nSimulation info\n";
   if (this->lSeg.size()!= 0)      this->printSegments();
   if (this->mCross.size()!= 0)    this->printCrossings();
   if (this->lRailnet.size()!= 0)  this->printRailnet();
   cout << "\n";
}


void Traffic::printSegments(){
   std::list<Segment*>::iterator   iter;
   cout << "\nList of Segments\n";
   for (iter = this->lSeg.begin(); iter != this->lSeg.end(); iter++)
       {(*iter)->print();cout << "\n"; };
}

void Traffic::printCrossings(){
   std::map<Point,Crossing*>::iterator   iter2;
   cout << "\nList of Crossings\n";
   for (iter2 = mCross.begin(); iter2 != mCross.end(); iter2++)
       { iter2->second->print();cout << "\n"; };
   }

void Traffic::printRailnet(){
   std::list<Railnet*>::iterator   iter;
   cout << "\nList of Railnets\n";
   for (iter = this->lRailnet.begin(); iter != this->lRailnet.end(); iter++)
       {(*iter)->print();cout << "\n"; };
}

void Traffic::validate(){
std::list<Segment*>::iterator  iterS;
bool hasInSeg;
bool hasOutSeg;
std::map<Point,Crossing*>::iterator  iterC;

for (iterS = this->lSeg.begin(); iterS != this->lSeg.end(); iterS++){
    if ((iterC=this->mCross.find((*iterS)->getFirstPoint())) != this->mCross.end() ){
       (*iterS)->setFirstCross(iterC->second);
       iterC->second->addSeg(*iterS);
    }
    if ((iterC=this->mCross.find((*iterS)->getSecondPoint())) != this->mCross.end() ){
       (*iterS)->setSecondCross(iterC->second);
       iterC->second->addSeg(*iterS);
    }
}


for (iterC = this->mCross.begin(); iterC != this->mCross.end(); iterC++){
   hasInSeg = false;
   hasOutSeg = false;
   iterS = iterC->second->getLSeg()->begin();
   while ((iterS != iterC->second->getLSeg()->end()) && (!hasInSeg || !hasOutSeg)){
   if ((*iterS)->getStartPoint() == iterC->second->getPoint())
      hasOutSeg = true;
   else
      hasInSeg = true;
   iterS++;
   }
   if (!hasInSeg){
      std::string m = "Crossing ";
      m += iterC->second->getIdent();
      m += " without any IN segments";
      throw TException("validate",m);
      }          
   if (!hasOutSeg){
      std::string m = "Crossing ";
      m += iterC->second->getIdent();
      m += " without any OUT segments";
      throw TException("validate",m);
      }   
   iterC->second->setQcell();       
}

}

