#include "codegen.h"

void CodeGen::generate(){

std::list<Segment*>*         lSeg = traffic.getLSeg();
std::map<Point,Crossing*>* mCross = traffic.getMCross();
std::list<Railnet*>*     lRailnet = traffic.getLRailnet();
std::list<RuleBlock>*         lrb;

std::map<std::string,Template>::iterator  iterM;
std::list<Segment*>::iterator       iterS;
std::map<Point,Crossing*>::iterator iterC;
std::map<std::string,Macro>::iterator    iterMC;
std::list<Railnet*>::iterator       iterRN;
std::list<RuleBlock>::iterator      iterRB;

fileAdmin.open();

//seteo todos los templates y todos los bloques a no usados
for (iterM = codeStruct.getMTemplate()->begin(); iterM != codeStruct.getMTemplate()->end(); iterM++){
    iterM->second.setWasUsed(false);
    for (iterRB = iterM->second.getRules()->begin(); iterRB != iterM->second.getRules()->end(); iterRB++)
       iterRB->setWasUsed(false);   
}

//seteo todos las macros a no usadas
for (iterMC = codeStruct.getMMacro()->begin(); iterMC != codeStruct.getMMacro()->end(); iterMC++)
    iterMC->second.setWasUsed(false);
     
//genero codigo para todos los segmentos
for (iterS = lSeg->begin(); iterS != lSeg->end(); iterS++){
    this->generateSegment(*iterS);
//  clearDepWasUsed();
}

//genero codigo para todos los cruces
for (iterC = mCross->begin(); iterC != mCross->end(); iterC++){
    this->generateCrossing(iterC->second);
//  clearDepWasUsed();
}
 
//genero codigo para todas las redes de vias (el sincronizador)
for (iterRN = lRailnet->begin(); iterRN != lRailnet->end(); iterRN++){
    this->generateRailnet(*iterRN);
//  clearDepWasUsed();
}
 
/****************
//genero las reglas independientes usadas
for (iterM = codeStruct.getMTemplate()->begin(); iterM != codeStruct.getMTemplate()->end(); iterM++)
    if (iterM->second.getWasUsed()){
       lrb = iterM->second.getRules();
       for (iterRB = lrb->begin(); iterRB != lrb->end(); iterRB++)
            if (!(*iterRB).getIsDependent())
               generateLine((*iterRB).getRules(),"rule");
    }
     
//genero las macros independientes usadas
for (iterMC = codeStruct.getMMacro()->begin(); iterMC != codeStruct.getMMacro()->end(); iterMC++)
    if(iterMC->second.getWasUsed() && !(iterMC->second.getIsDependent()))
       generateLine(iterMC->second.getLines(),"macro");

*************/

fileAdmin.close();

}


void CodeGen::generateSegment(Segment* s){  

call=&Template::getTopComponents;
generateLineSegmentCall(s,"topC");

call=&Template::getTopLinks;
generateLineSegmentCall(s,"topL");

call=&Template::getBeforeNeighbors;
generateLineSegmentCall(s,"body");

call=&Template::getNeighbors;
generateLineSegmentCall(s,"body");

call=&Template::getBeforePorts;
generateLineSegmentCall(s,"body");

call=&Template::getPorts;
generateLineSegmentCall(s,"body");

call=&Template::getBeforeLinks;
generateLineSegmentCall(s,"body");

call=&Template::getLinks;
generateLineSegmentCall(s,"body");

call=&Template::getBeforeZones;
generateLineSegmentCall(s,"body");

call=&Template::getZones;
generateLineSegmentCall(s,"body");

call=&Template::getBeforeRules;
generateLineSegmentCall(s,"body");

generateRuleSegmentCall(s,"rule");

call=&Template::getAfterRules;
generateLineSegmentCall(s,"body");
}



void CodeGen::generateLineSegmentCall(Segment* s,std::string where){  
TemplateName* tn;
Template* se;
std::list<Jobsite>::iterator iterJ;
std::list<Hole>::iterator iterH;
std::list<CtrElem>::iterator iterC;
std::list<Railnet*>::iterator iterR;

if (s->getLJobsite()->size() != 0)
for (iterJ = s->getLJobsite()->begin(); iterJ != s->getLJobsite()->end(); iterJ++){
    se = codeStruct.getTemplate(tn->getTNJobsite(&*iterJ));
    generateLineJobsite(&*iterJ,(se->*call)(),where);
    se->setWasUsed(true);
}

if (s->getLHole()->size() != 0)
for (iterH = s->getLHole()->begin(); iterH != s->getLHole()->end(); iterH++){
    se = codeStruct.getTemplate(tn->getTNHole(&*iterH));
    generateLineHole(&*iterH,(se->*call)(),where);
    se->setWasUsed(true);
}

if (s->getLCtrElem()->size() != 0)
for (iterC = s->getLCtrElem()->begin(); iterC != s->getLCtrElem()->end(); iterC++){
    se = codeStruct.getTemplate(tn->getTNCtrElem(&*iterC));
    generateLineCtrElem(&*iterC,(se->*call)(),where);
    se->setWasUsed(true);
}

if (s->getLRailnet()->size() != 0)
for (iterR = s->getLRailnet()->begin(); iterR != s->getLRailnet()->end(); iterR++){
    se = codeStruct.getTemplate(tn->getTNRail(s));
    generateLineRail(s,*iterR,(se->*call)(),where);
    se->setWasUsed(true);
}

if (s->getTLight()=="withTL"){
   se = codeStruct.getTemplate(tn->getTNSegmentTL(s));
   generateLineSegment(s,(se->*call)(),where);
   se->setWasUsed(true);
}

se = codeStruct.getTemplate(tn->getTNSegmentStart(s));
generateLineSegment(s,(se->*call)(),where);
se->setWasUsed(true);

se = codeStruct.getTemplate(tn->getTNSegmentEnd(s));
generateLineSegment(s,(se->*call)(),where);
se->setWasUsed(true);

se = codeStruct.getTemplate(tn->getTNSegment(s));
generateLineSegment(s,(se->*call)(),where);
se->setWasUsed(true);
}

void CodeGen::generateRuleSegmentCall(Segment* s,std::string where){  
TemplateName* tn;
Template* se;
std::list<Jobsite>::iterator iterJ;
std::list<Hole>::iterator iterH;
std::list<CtrElem>::iterator iterC;
std::list<Railnet*>::iterator iterRN;
std::list<RuleBlock>* lrb;
std::list<RuleBlock>::iterator iter;


if (s->getLJobsite()->size() != 0)
for (iterJ = s->getLJobsite()->begin(); iterJ != s->getLJobsite()->end(); iterJ++){
    clearDepWasUsed();
    se = codeStruct.getTemplate(tn->getTNJobsite(&*iterJ));
    lrb = se->getRules();
    for (iter = lrb->begin(); iter != lrb->end(); iter++)
       if (!(*iter).getWasUsed()){
           generateLineJobsite(&*iterJ,(*iter).getRules(),where);
          (*iter).setWasUsed(true);
       }
}

if (s->getLHole()->size() != 0)
for (iterH = s->getLHole()->begin(); iterH != s->getLHole()->end(); iterH++){
    clearDepWasUsed();
    se = codeStruct.getTemplate(tn->getTNHole(&*iterH));
    lrb = se->getRules();
    for (iter = lrb->begin(); iter != lrb->end(); iter++)
       if (!(*iter).getWasUsed()){
           generateLineHole(&*iterH,(*iter).getRules(),where);
          (*iter).setWasUsed(true);
       }
}
 
if (s->getLCtrElem()->size() != 0)
for (iterC = s->getLCtrElem()->begin(); iterC != s->getLCtrElem()->end(); iterC++){
    clearDepWasUsed();
    se = codeStruct.getTemplate(tn->getTNCtrElem(&*iterC));
    lrb = se->getRules();
    for (iter = lrb->begin(); iter != lrb->end(); iter++)
       if (!(*iter).getWasUsed()){
           generateLineCtrElem(&*iterC,(*iter).getRules(),where);
          (*iter).setWasUsed(true);
       }
}

if (s->getLRailnet()->size() != 0)
for (iterRN = s->getLRailnet()->begin(); iterRN != s->getLRailnet()->end(); iterRN++){
    clearDepWasUsed();
    se = codeStruct.getTemplate(tn->getTNRail(s));
    lrb = se->getRules();
    for (iter = lrb->begin(); iter != lrb->end(); iter++)
       if (!(*iter).getWasUsed()){
           generateLineRail(s,*iterRN,(*iter).getRules(),where);
          (*iter).setWasUsed(true);
       }
}

clearDepWasUsed();

if (s->getTLight()=="withTL"){
   se = codeStruct.getTemplate(tn->getTNSegmentTL(s));
   lrb = se->getRules();
   for (iter = lrb->begin(); iter != lrb->end(); iter++)
       if (!(*iter).getWasUsed()){
          generateLineSegment(s,(*iter).getRules(),where);
          (*iter).setWasUsed(true);
       }
}

se = codeStruct.getTemplate(tn->getTNSegmentStart(s));
lrb = se->getRules();
for (iter = lrb->begin(); iter != lrb->end(); iter++)
   if (!(*iter).getWasUsed()){
       generateLineSegment(s,(*iter).getRules(),where);
      (*iter).setWasUsed(true);
   }

se = codeStruct.getTemplate(tn->getTNSegmentEnd(s));
lrb = se->getRules();
for (iter = lrb->begin(); iter != lrb->end(); iter++)
   if (!(*iter).getWasUsed()){
       generateLineSegment(s,(*iter).getRules(),where);
      (*iter).setWasUsed(true);
   }

se = codeStruct.getTemplate(tn->getTNSegment(s));
lrb = se->getRules();
for (iter = lrb->begin(); iter != lrb->end(); iter++)
   if (!(*iter).getWasUsed()){
       generateLineSegment(s,(*iter).getRules(),where);
      (*iter).setWasUsed(true);
   }
}


void CodeGen::generateLineSegment(Segment* s,std::list<std::string>* ls,std::string where){  
LineConvertor lc;
std::list<std::string>::iterator iter1,iter2;
std::string macroName;
Macro * macro;
for (iter1 = ls->begin(); iter1 != ls->end(); iter1++){
    fileAdmin.write(lc.convertSegment(*iter1,s),where);
    if (where == "rule" && (macroName=getMacroName(*iter1)) != ""){
        macro = codeStruct.getMacro(macroName);
        if (!macro->getWasUsed())
            for (iter2 = macro->getLines()->begin(); iter2 != macro->getLines()->end(); iter2++)
                 fileAdmin.write(lc.convertSegment(*iter2,s),"macro");
        macro->setWasUsed(true);
    }
}
}

void CodeGen::generateLineHole(Hole* h,std::list<std::string>* ls,std::string where){
LineConvertor lc;
std::list<std::string>::iterator iter1,iter2;
std::string macroName;
Macro * macro;
for (iter1 = ls->begin(); iter1 != ls->end(); iter1++){
    fileAdmin.write(lc.convertSegment(lc.convertHole(*iter1,h),h->getSegment()),where);
    if (where == "rule" && (macroName=getMacroName(*iter1)) != ""){
        macro = codeStruct.getMacro(macroName);
        if (!macro->getWasUsed())
            for (iter2 = macro->getLines()->begin(); iter2 != macro->getLines()->end(); iter2++)
                 fileAdmin.write(lc.convertSegment(lc.convertHole(*iter2,h),h->getSegment()),"macro");
        macro->setWasUsed(true);
    }
}
}



void CodeGen::generateLineJobsite(Jobsite* j,std::list<std::string>* ls,std::string where){
LineConvertor lc;
std::list<std::string>::iterator iter1,iter2;
std::string macroName;
Macro * macro;
for (iter1 = ls->begin(); iter1 != ls->end(); iter1++){
    fileAdmin.write(lc.convertSegment(lc.convertJobsite(*iter1,j),j->getSegment()),where);
    if (where == "rule" && (macroName=getMacroName(*iter1)) != ""){
        macro = codeStruct.getMacro(macroName);
        if (!macro->getWasUsed())
            for (iter2 = macro->getLines()->begin(); iter2 != macro->getLines()->end(); iter2++)
                 fileAdmin.write(lc.convertSegment(lc.convertJobsite(*iter2,j),j->getSegment()),"macro");
        macro->setWasUsed(true);

    }
}
}

void CodeGen::generateLineCtrElem(CtrElem* c,std::list<std::string>* ls,std::string where){
LineConvertor lc;
std::list<std::string>::iterator iter1,iter2;
std::string macroName;
Macro * macro;
for (iter1 = ls->begin(); iter1 != ls->end(); iter1++){
    fileAdmin.write(lc.convertSegment(lc.convertCtrElem(*iter1,c),c->getSegment()),where);
    if (where == "rule" && (macroName=getMacroName(*iter1)) != ""){
        macro = codeStruct.getMacro(macroName);
        if (!macro->getWasUsed())
            for (iter2 = macro->getLines()->begin(); iter2 != macro->getLines()->end(); iter2++)
                 fileAdmin.write(lc.convertSegment(lc.convertCtrElem(*iter2,c),c->getSegment()),"macro");
        macro->setWasUsed(true);

    }
}
}

void CodeGen::generateLineRail(Segment* s,Railnet* r,std::list<std::string>* ls,std::string where){
LineConvertor lc;
std::list<std::string>::iterator iter1,iter2;
std::string macroName;
Macro * macro;
for (iter1 = ls->begin(); iter1 != ls->end(); iter1++){
    fileAdmin.write(lc.convertSegment(lc.convertRail(*iter1,s,r),s),where);
    if (where == "rule" && (macroName=getMacroName(*iter1)) != ""){
        macro = codeStruct.getMacro(macroName);
        if (!macro->getWasUsed())
            for (iter2 = macro->getLines()->begin(); iter2 != macro->getLines()->end(); iter2++)
                 fileAdmin.write(lc.convertSegment(lc.convertRail(*iter2,s,r),s),"macro");
        macro->setWasUsed(true);

    }
}
}


void CodeGen::generateCrossing(Crossing* c){

call=&Template::getTopComponents;
generateLineCrossingCall(c,"topC");

call=&Template::getTopLinks;
generateLineCrossingCall(c,"topL");

call=&Template::getBeforeNeighbors;
generateLineCrossingCall(c,"body");

call=&Template::getNeighbors;
generateLineCrossingCall(c,"body");

call=&Template::getBeforePorts;
generateLineCrossingCall(c,"body");

call=&Template::getPorts;
generateLineCrossingCall(c,"body");

call=&Template::getBeforeLinks;
generateLineCrossingCall(c,"body");

call=&Template::getLinks;
generateLineCrossingCall(c,"body");

call=&Template::getBeforeZones;
generateLineCrossingCall(c,"body");

call=&Template::getZones;
generateLineCrossingCall(c,"body");

call=&Template::getBeforeRules;
generateLineCrossingCall(c,"body");

generateRuleCrossingCall(c,"rule");

call=&Template::getAfterRules;
generateLineCrossingCall(c,"body");
}

void CodeGen::generateLineCrossingCall(Crossing* c,std::string where){  
TemplateName* tn;
Template* se;

se = codeStruct.getTemplate(tn->getTNCrossingHole(c));
generateLineCrossing(c,(se->*call)(),where);
se->setWasUsed(true);

if (c->getTLight()=="withTL"){
   se = codeStruct.getTemplate(tn->getTNCrossingTL());
   generateLineCrossing(c,(se->*call)(),where);
   se->setWasUsed(true);
}

se = codeStruct.getTemplate(tn->getTNCrossing());
generateLineCrossing(c,(se->*call)(),where);
se->setWasUsed(true);
}

void CodeGen::generateRuleCrossingCall(Crossing* c,std::string where){  
TemplateName* tn;
Template* se;
std::list<RuleBlock>* lrb;
std::list<RuleBlock>::iterator iter;

clearDepWasUsed();
se = codeStruct.getTemplate(tn->getTNCrossingHole(c));
lrb = se->getRules();
for (iter = lrb->begin(); iter != lrb->end(); iter++)
    if (!(*iter).getWasUsed()){
       generateLineCrossing(c,(*iter).getRules(),where);
       (*iter).setWasUsed(true);
    }

if (c->getTLight()=="withTL"){
   se = codeStruct.getTemplate(tn->getTNCrossingTL());
   lrb = se->getRules();
   for (iter = lrb->begin(); iter != lrb->end(); iter++)
      if (!(*iter).getWasUsed()){
          generateLineCrossing(c,(*iter).getRules(),where);
         (*iter).setWasUsed(true);
      }
}

se = codeStruct.getTemplate(tn->getTNCrossing());
lrb = se->getRules();
for (iter = lrb->begin(); iter != lrb->end(); iter++)
    if (!(*iter).getWasUsed()){
       generateLineCrossing(c,(*iter).getRules(),where);
       (*iter).setWasUsed(true);
    }
}

void CodeGen::generateLineCrossing(Crossing* c,std::list<std::string>* ls,std::string where){  
LineConvertor lc;
std::list<std::string>::iterator iter1,iter2;
std::string macroName;
Macro * macro;
for (iter1 = ls->begin(); iter1 != ls->end(); iter1++){
    fileAdmin.write(lc.convertCrossing(*iter1,c),where);
    if (where == "rule" && (macroName=getMacroName(*iter1)) != ""){
        macro = codeStruct.getMacro(macroName);
        if (!macro->getWasUsed())
            for (iter2 = macro->getLines()->begin(); iter2 != macro->getLines()->end(); iter2++)
                 fileAdmin.write(lc.convertCrossing(*iter2,c),"macro");
        macro->setWasUsed(true);

    }
}
}

void CodeGen::generateRailnet(Railnet* r){
Template* se;
TemplateName* tn;
se = codeStruct.getTemplate(tn->getTNSincroRailnet());

generateLineRailnet(r,se->getTopComponents(),"topC");
generateLineRailnet(r,se->getTopLinks(),"topL");
generateLineRailnet(r,se->getBeforeNeighbors(),"body");
generateLineRailnet(r,se->getNeighbors(),"body");
generateLineRailnet(r,se->getBeforePorts(),"body");
generateLineRailnet(r,se->getPorts(),"body");
generateLineRailnet(r,se->getBeforeLinks(),"body");
generateLineRailnet(r,se->getLinks(),"body");
generateLineRailnet(r,se->getBeforeZones(),"body");
generateLineRailnet(r,se->getZones(),"body");
generateLineRailnet(r,se->getBeforeRules(),"body");

std::list<RuleBlock>* lrb;
std::list<RuleBlock>::iterator iter;
lrb = se->getRules();
clearDepWasUsed();
for (iter = lrb->begin(); iter != lrb->end(); iter++)
    if (!(*iter).getWasUsed()){
       generateLineRailnet(r,(*iter).getRules(),"rule");
       (*iter).setWasUsed(true);
    }

generateLineRailnet(r,se->getAfterRules(),"body");
se->setWasUsed(true);
}

void CodeGen::generateLineRailnet(Railnet* r,std::list<std::string>* ls,std::string where){  
LineConvertor lc;
std::list<std::string>::iterator iter1,iter2;
std::string macroName;
Macro * macro;
for (iter1 = ls->begin(); iter1 != ls->end(); iter1++){
    fileAdmin.write(lc.convertRailnet(*iter1,r),where);
    if (where == "rule" && (macroName=getMacroName(*iter1)) != ""){
        macro = codeStruct.getMacro(macroName);
        if (!macro->getWasUsed())
            for (iter2 = macro->getLines()->begin(); iter2 != macro->getLines()->end(); iter2++)
                 fileAdmin.write(lc.convertRailnet(*iter2,r),"macro");
        macro->setWasUsed(true);
    }
}
}
/****************
void CodeGen::generateLine(std::list<std::string>* ls,std::string where){  
std::list<std::string>::iterator iter;
std::string macroName;
for (iter = ls->begin(); iter != ls->end(); iter++){
    fileAdmin.write(*iter,where);
    if (where == "rule"){
        macroName = getMacroName(*iter);
        if (macroName != "")
            codeStruct.getMacro(macroName)->setWasUsed(true);
    }
}
}
**************/

void CodeGen::clearDepWasUsed(){

std::map<std::string,Template>::iterator  iterM;
std::map<std::string,Macro>::iterator    iterMC;
std::list<RuleBlock>::iterator      iterRB;

//seteo todos los bloques dependientes a no usados
for (iterM = codeStruct.getMTemplate()->begin(); iterM != codeStruct.getMTemplate()->end(); iterM++)
    for (iterRB = iterM->second.getRules()->begin(); iterRB != iterM->second.getRules()->end(); iterRB++)
        if ((*iterRB).getIsDependent()) 
           iterRB->setWasUsed(false);   

//seteo todas las macros dependientes a no usadas
for (iterMC = codeStruct.getMMacro()->begin(); iterMC != codeStruct.getMMacro()->end(); iterMC++)
    if (iterMC->second.getIsDependent())
       iterMC->second.setWasUsed(false);
}
